/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.sqladmin.model;

import com.google.api.client.json.GenericJson;

/**
 * Database instance export context.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud SQL Administration API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ExportContext extends GenericJson {

  /**
   * Databases (for example, guestbook) from which the export is made. If unspecified, all databases
   * are exported.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<String> database;

  /**
   * This is always sql#exportContext.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Tables to export, or that were exported, from the specified database. If you specify tables,
   * specify one and only one database.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<String> table;

  /**
   * The path to the file in Google Cloud Storage where the export will be stored, or where it was
   * already stored. The URI is in the form gs://bucketName/fileName. If the file already exists,
   * the operation fails. If the filename ends with .gz, the contents are compressed.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String uri;

  /**
   * Databases (for example, guestbook) from which the export is made. If unspecified, all databases
   * are exported.
   * The value returned may be {@code null}.
   */
  public java.util.List<String> getDatabase() {
    return database;
  }

  /**
   * Databases (for example, guestbook) from which the export is made. If unspecified, all databases
   * are exported.
   * The value set may be {@code null}.
   */
  public ExportContext setDatabase(java.util.List<String> database) {
    this.database = database;
    return this;
  }

  /**
   * This is always sql#exportContext.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * This is always sql#exportContext.
   * The value set may be {@code null}.
   */
  public ExportContext setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Tables to export, or that were exported, from the specified database. If you specify tables,
   * specify one and only one database.
   * The value returned may be {@code null}.
   */
  public java.util.List<String> getTable() {
    return table;
  }

  /**
   * Tables to export, or that were exported, from the specified database. If you specify tables,
   * specify one and only one database.
   * The value set may be {@code null}.
   */
  public ExportContext setTable(java.util.List<String> table) {
    this.table = table;
    return this;
  }

  /**
   * The path to the file in Google Cloud Storage where the export will be stored, or where it was
   * already stored. The URI is in the form gs://bucketName/fileName. If the file already exists,
   * the operation fails. If the filename ends with .gz, the contents are compressed.
   * The value returned may be {@code null}.
   */
  public String getUri() {
    return uri;
  }

  /**
   * The path to the file in Google Cloud Storage where the export will be stored, or where it was
   * already stored. The URI is in the form gs://bucketName/fileName. If the file already exists,
   * the operation fails. If the filename ends with .gz, the contents are compressed.
   * The value set may be {@code null}.
   */
  public ExportContext setUri(String uri) {
    this.uri = uri;
    return this;
  }

}
