/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.sqladmin.model;

import com.google.api.client.json.GenericJson;

/**
 * Database instance import context.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud SQL Administration API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ImportContext extends GenericJson {

  /**
   * The database (for example, guestbook) to which the import is made. If not set, it is assumed
   * that the database is specified in the file to be imported.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String database;

  /**
   * This is always sql#importContext.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * A path to the MySQL dump file in Google Cloud Storage from which the import is made. The URI is
   * in the form gs://bucketName/fileName. Compressed gzip files (.gz) are also supported.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<String> uri;

  /**
   * The database (for example, guestbook) to which the import is made. If not set, it is assumed
   * that the database is specified in the file to be imported.
   * The value returned may be {@code null}.
   */
  public String getDatabase() {
    return database;
  }

  /**
   * The database (for example, guestbook) to which the import is made. If not set, it is assumed
   * that the database is specified in the file to be imported.
   * The value set may be {@code null}.
   */
  public ImportContext setDatabase(String database) {
    this.database = database;
    return this;
  }

  /**
   * This is always sql#importContext.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * This is always sql#importContext.
   * The value set may be {@code null}.
   */
  public ImportContext setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * A path to the MySQL dump file in Google Cloud Storage from which the import is made. The URI is
   * in the form gs://bucketName/fileName. Compressed gzip files (.gz) are also supported.
   * The value returned may be {@code null}.
   */
  public java.util.List<String> getUri() {
    return uri;
  }

  /**
   * A path to the MySQL dump file in Google Cloud Storage from which the import is made. The URI is
   * in the form gs://bucketName/fileName. Compressed gzip files (.gz) are also supported.
   * The value set may be {@code null}.
   */
  public ImportContext setUri(java.util.List<String> uri) {
    this.uri = uri;
    return this;
  }

}
